$(function() {
  $("#cadastre").send(function(data) {
    if (data == "email_error") {
      $.alert("Email já cadastrado, por favor, utilize outro email para completar o cadastro!");
    } else {
      $.dialog.close();
      $("#view-cadastre-form").velocity("transition.expandOut", 300, {
        display: "none"
      });
      $.dialog.info("Cadastro concluído", "Seu cadastro foi concluído com sucesso. Agora você pode chamar um mototáxi.");
      viewIndex();
      hasLogout();
      localStorage.setItem("user", data);
    }
  }, function() {
    $.alert("Erro ao realizar cadastro.");
  });

  $("#login").send(function(data) {
    if (data) {
      $.dialog.close();
      localStorage.setItem("user", data);
      $.alert("Login realizado.");
      hasLogout();
      viewIndex();
      sendCall();
    } else {
      $.alert("Email e senha não conferem.");
    }
  }, function() {
    $.alert("Erro ao realizar login.");
  });

  /*CLICA NO BOTÃO PARA LOGIN*/
  $(".btn-login").unbind("tapstart").on("tapstart", function() {
    $(".menu .menu-icon").html("&#xE5C4;");
    $(".menu .menu-title").html("Login");
    $(".action-menu").unbind("tapstart").on("tapstart", function() {
      viewLogin();
    });
    transitionView("#view-login-form");
  });

  /*CLICA NO BOTÃO PARA CADASTRAR*/
  $(".btn-cadastre").on("tapstart", function() {
    $(".menu .menu-icon").html("&#xE5C4;");
    $(".menu .menu-title").html("Nova conta");
    $(".action-menu").unbind("tapstart").on("tapstart", function() {
      viewLogin();
    });
    transitionView("#view-cadastre-form");
  });

  /*Aciona a view #tariff*/
  $("a[href='#tariff']").unbind("tapstart").on("tapstart", function() {
    $("#panel-menu").velocity("transition.slideLeftOut", 100, {
      display: "none"
    });
    $(".menu .menu-title").html("Tabela de preços");
    $("li", ".list-menu").removeClass("active");
    $(this).closest("li").addClass("active");
    transitionView("#view-tariff");
  });

  $("a[href='#index']").unbind("tapstart").on("tapstart", function() {
    $("li", ".list-menu").removeClass("active");
    $(this).closest("li").addClass("active");
    $("#panel-menu").velocity("transition.slideLeftOut", 100, {
      display: "none"
    });
    viewIndex();
  });

  $("#logout").unbind("tapstart").on("tapstart", function() {
    user.logout();
  });

  /*RECUPERAÇÂO DE SENHA*/
  $(".link[mission='recover-password']").unbind("tapstart").on("tapstart", function() {
    $(".menu .menu-title").html("Recuperar senha");
    $(".action-menu").unbind("tapstart").on("tapstart", function() {
      $(".btn-login").tap();
    });
    transitionView("#view-recover-form");
  });

  $("#recover button").on("tapstart", function() {
    $("#recover").send(function(data) {
      $.dialog.close();
      $.alert("Um email de recuperação foi enviado.");
    }, function() {
      $.alert("Erro. Tente novamente mais tarde.");
    });
  });

  /*EVENTO SHOW PASSWORD*/
  showPassword();
  viewIndex();


});

/*EVENTOS DE AVALIAÇÃO DA CORRIDA
 *Mostra o panel de avaliação
 */
function showRating() {
  var rating = 0;
  $("li", ".list-avaliable").unbind("tapstart").on("tapstart", function() {
    rating = $(this).prevAll().andSelf().length;
    $(this).nextAll().find("i").html("&#xE83A;").removeClass("icon-star");
    $(this).prevAll().andSelf().find("i").html("&#xE838;").addClass("icon-star");
  });

  $(".send-rating", ".list-avaliable").unbind('tapstart').on("tapstart", function() {
    $.post("avaliable-worker", {
        rating: rating,
        comment: $("textarea[name='comment']", "#view-rating").val()
      },
      function(data) {
        $.alert("Avaliação enviada.");
      },
      function(data) {
        $.alert("Ops. Aconteceu um erro no envio da avaliação");
      });
    closeRating();
  });

  $(".cancel-rating", ".list-avaliable").unbind('tapstart').on("tapstart", function() {
    closeRating();
  });

  $("#view-rating").velocity("transition.expandIn", 100, {
    display: 'block'
  });
  $(".overlay").show(0);
}

function closeRating() {
  $("#view-rating").velocity("transition.expandOut", 100, {
    display: 'none'
  });
  $(".overlay").hide(0);
}

function transitionView(id) {
  var effect = [{
    e: $(".all-views"),
    p: "transition.slideLeftOut",
    o: {
      duration: 100,
      display: "none"
    }
  }, {
    e: $(id),
    p: "transition.slideRightIn",
    o: {
      duration: 100,
      display: "block"
    }
  }];
  $.Velocity.RunSequence(effect);
}

/*Eventos da view index*/
function viewIndex() {
  $(".menu .menu-title").html("Taximoto");
  $(".menu .menu-icon").html("&#xE5D2;");
  $(".action-menu").unbind("tapstart").on("tapstart", function() {
    $(".menu .menu-option").show(0);
    //$(".menu .menu-title").html("Menu");
    $(".menu-exit", "#panel-menu").unbind("tapstart").on("tapstart", function() {
      //$(".menu .menu-title").html("Taximoto");
      $("#panel-menu").velocity("transition.slideRightOut", 100, {
        display: "none"
      });
    })
    $(".panel-menu").velocity("transition.slideLeftIn", 100, {
      display: "block"
    });
  });
  transitionView("#index");
  hasLogout();
}


/*Eventos da view login*/
function viewLogin() {
  $(".menu .menu-icon").html("&#xE5C4;");
  $(".menu .menu-title").html("Bem vindo");
  $(".action-menu").unbind("tapstart").on("tapstart", function() {
    $(".menu .menu-icon").html("&#xE5D2;");
    viewIndex();
  });
  transitionView("#view-login");
  hasLogout();
}

function hasLogout() {
  if (localStorage.user) {
    $("#logout").show();
  } else $("#logout").hide();
}

function resizeMap() {
  $("#google-maps").outerHeight(function() {
    return $(".app").height() - $(".panel-action-bottom").outerHeight();
  });
}

function showPassword() {
  $(".showPassword").on("tapstart", function() {
    if ($(this).attr("show") == 0) {
      $(this).prev("input[name='password']").attr("type", "text");
      $(this).text("OCULTAR").attr("show", 1);
    } else {
      $(this).prev("input[name='password']").attr("type", "password");
      $(this).text("MOSTRAR").attr("show", 0);
    }
  });
}


function definedString(data) {
  if (typeof data === "undefined")
    return "";
  else return data;
}

function getMotoOnline() {
  $.post("online-workers", {
      lat: aLatitude,
      lng: aLongitude
    },
    function(data) {
      $(".moto-online").html(data.qtd + " online").show();
    },
    function() {
      console.error("Erro ao solicitar quantidade de mototaxistas.");
    });
}
