var connection = {

  initialize: function() {
    cordova.plugins.diagnostic.getLocationMode(function(mode) {
      if (mode != "high_accuracy") {
        $.dialog.confirm(
          "Ativar GPS",
          "Por favor, ative o GPS na opção <b>Alta precisão</b> ou habilite todas as opções do gps para que o aplicativo possa funcionar corretamente",
          function() {
            cordova.plugins.diagnostic.switchToLocationSettings();
            $.dialog.close();
            navigator.app.exitApp();
          },
          function() {
            navigator.app.exitApp();
          }
        );
      } else {
        connection.checkConnection();
      }
    }, function(error) {
      navigator.app.exitApp();
    });
  },

  checkConnection: function() {
    if (navigator.connection.type == Connection.NONE) {
      $.dialog.info(
        "Sem conectividade",
        "Para utilizar o Taximoto é necessário ter conexão com a internet. Por favor, ative o WiFi ou a 3G."
      );
      $('.user-local').html("Aguardando conexão");
      document.addEventListener("online", connection.restart);
    } else {
      gps.initialize();
    }
  },

  restart: function() {
    gps.initialize();
    document.removeEventListener("online", connection.restart);
  }

}
