var gcm = {

  initialize: function() {
    if (device.platform == 'android' || device.platform == 'Android') {
      pushNotification.register(
        successHandler,
        errorHandler, {
          "senderID": "898793747775",
          "ecb": "onNotificationGCM"
        }
      );
    } else {
      pushNotification.register(
        tokenHandler,
        errorHandler, {
          "badge": "true",
          "sound": "true",
          "alert": "true",
          "ecb": "onNotificationAPN"
        }
      );
    }
    return 1;
  }

};

// result contains any message sent from the plugin call
function successHandler(result) {
  // debug.msg('result = ' + result);
}

// result contains any error description text returned from the plugin call
function errorHandler(error) {
  // debug.msg('error = ' + error);
}

// Android
function onNotificationGCM(e) {
  switch (e.event) {
    case 'registered':
      if (e.regid.length > 0) {
        user.setGcm(e.regid);
        user.ping();
      }
      break;

    case 'message':
      // if this flag is set, this notification happened while we were in the foreground.
      // you might want to play a sound to get the user's attention, throw up a dialog, etc.
      if (e.foreground) {
        // debug.msg('--INLINE NOTIFICATION--');
        // if the notification contains a soundname, play it.
        var my_media = new Media("/android_asset/www/" + e.soundname);
        my_media.play();
      } else { // otherwise we were launched because the user touched a notification in the notification tray.
        if (e.coldstart) {
          // debug.msg('--COLDSTART NOTIFICATION--');
        } else {
          // debug.msg('--BACKGROUND NOTIFICATION--');
        }
      }

      // debug.msg('MESSAGE -> MSG: ' + e.payload.message);
      // debug.msg('MESSAGE -> MSGCNT: ' + e.payload.msgcnt);
      break;

    case 'error':
      // debug.msg('ERROR -> MSG:' + e.msg);
      break;

    default:
      // debug.msg('EVENT -> Unknown, an event was received and we do not know what it is');
      break;
  }
}
