(function($) {
  $.alert = function(m, t) {
    t = t || 5000;
    id = "toast-" + Date.now();

    $("#toast-container").show(0);

    html = '<div id="' + id + '" class="toast-alert toast">\
              <div class="toast-message">' + m + '</div>\
              <div class="fa fa-lg fa-close toast-close" hidden></div>\
            </div>';

    $("#toast-container").append(html);
    $("#" + id).addClass("toast-show");

    $("#" + id + " .toast-close").click(function() {
      var toast = $(this).closest(".toast");
      $(toast).removeClass("toast-show");
      setTimeout(function(toast) {
        $(toast).remove();
      }, 300, toast);
    });

    setTimeout(function(id) {
      $("#" + id + " .toast-close").click();
    }, t, id);

    return false;
  }

})(jQuery);

(function() {

  $.dialog = new function() {

    /*Diálogo de espera*/
    this.waiting = function(m) {
      html = '<div class="dialog z-depth-1" hidden>\
<div class="dialog-body text-center">' + m + '</div>\
</div>';
      this.open(html);
    };

    /*Diálogo de confirmação
     executa uma função.
    */
    this.confirm = function(title, m, func1, func2) {
      func1 = func1 || "";
      func2 = func2 || "";
      html = '<div class="dialog z-depth-1" hidden>\
<div class="dialog-header">' + title + '</div>\
<div class="dialog-body">' + m + '</div>\
<div class="dialog-footer">\
<button class="btn-flat dialog-cancel waves-effect">CANCELAR</button>\
<button class="btn-flat dialog-ok waves-effect">OK</button>\
</div>\
</div>';
      this.open(html);

      $(".dialog-cancel").on("tapstart, click", function() {
        $.dialog.close();
        if (typeof func2 == "function") func2();
      });

      $(".dialog-ok").on("tapstart, click", function() {
        $.dialog.close();
        if (typeof func1 == "function") func1();
      });
    };


    /*Diálogo de prompt
     executa uma função.
    */
    this.prompt = function(title, m, label, selector, value, func) {
      func = func || "";
      html = '<div class="dialog z-depth-1" hidden>\
<div class="dialog-header">' + title + '</div>\
<div class="dialog-body">' + m + '\
  <br><br>\
  <label>' + label + '</label>\
  <div class="form-group">\
    <input  class="' + selector + '" name="' + selector + '" value= "' + value + '" autofocus type="text"></form-group>\
</div>\
<div class="dialog-footer">\
<button class="btn-flat dialog-cancel waves-effect">CANCELAR</button>\
<button class="btn-flat dialog-ok waves-effect">OK</button>\
</div>\
</div>';
      this.open(html);

      $(".dialog-cancel").on("tapstart", function() {
        $.dialog.close();
      });

      $(".dialog-ok").on("tapstart", func);

    };

    /*Diálogo de informação*/
    this.info = function(title, m) {
      html = '<div class="dialog z-depth-1">\
<div class="dialog-header">' + title + '</div>\
<div class="dialog-body">' + m + '</div>\
<div class="dialog-footer">\
<button class="btn-flat btn-block dialog-cancel waves-effect">FECHAR</button>\
</div>\
</div>';
      this.open(html);
      $(".dialog-cancel").on("tapstart", function() {
        $.dialog.close();
      });
    };

    /*Coloca o diálogo no final do Body e show().*/
    this.open = function(html) {
      //      var modelo = '<div class="dialog z-depth-1" hidden>\
      //<div class="dialog-header">\
      //</div>\
      //<div class="dialog-body">\
      //</div>\
      //<div class="dialog-footer">\
      //<div class="text-right">\
      //<button class="btn-flat dialog-cancel waves-effect">CANCELAR</button>\
      //<button class="btn-flat dialog-ok waves-effect">OK</button>\
      //</div>\
      //</div>\
      //</div>';

      $("body").append(html);

      var winH = $(window).height();
      var winW = $(window).width();

      //console.log([winH, winW]);

      if (winW <= 480) {
        $(".dialog").width(winW - 40);
      }
      //console.log([$(".dialog").height(), $(".dialog").width()]);

      var boxH = $(".dialog").height();
      var boxW = $(".dialog").width();
      $(".overlay").show(0);

      $(".dialog").offset({
        top: winH / 2 - boxH / 2,
        left: winW / 2 - boxW / 2
      }).show(0);

      //      $(".overlay").click(function(){
      //        $.dialog.close();
      //      });

      $(document).keyup(function(e) {
        if (e.keyCode == 27) {
          $(".overlay").hide(0);
          $(".dialog").remove();
        }
      });
    };

    this.close = function() {
      $(".overlay").hide(0);
      $(".dialog").remove();
    }



  };

})(jQuery);
