/**
 * Objeto que controla dados do usuário
 * @type {Object}
 */
var user = {

  /**
   * @return {string} - Id do usuário criptografado
   */
  getId: function() {
    return localStorage.user;
  },

  /**
   * @param {string} - Id do usuário criptografado
   */
  setId: function(id) {
    localStorage.user = id;
  },

  /**
   * @return {string} - gcmid
   */
  getGcm: function() {
    return localStorage.gcmid;
  },

  /**
   * @param {string} - gcmid
   */
  setGcm: function(gcm) {
    localStorage.gcmid = gcm;
  },

  /**
   * Retorna o id da cidade onde o usuário se encontra
   * @return {[type]} [description]
   */
  getPlaceId: function() {
    return localStorage.placeId;
  },

  /**
   * Registra o ID da cidade onde o usuário se encontra
   * @param {[type]} place [description]
   */
  setPlaceId: function(place) {
    localStorage.placeId = place;
  },

  /**
   * @return {null}
   */
  ping: function() {
    var data = {
      id: this.getId(),
      latitude: aLatitude,
      longitude: aLongitude,
      model: device.model,
      version_so: device.version,
      uuid: device.uuid,
      gcm: this.getGcm(),
      version_app: versionApp
    };
    // alert(JSON.stringify(data));
    $.post("ping", data, function(data) {
      localStorage.status = data;
      if (data == "D") {
        $.dialog.info("Bloqueado", "Sua conta foi bloqueada. Entre em contato com suporte@taximoto.com.");
      }
      return true;
    }, function() {
      $.alert("Erro ao conectar com o servidor.");
      return false;
    });
  },

  logout: function() {
    $.dialog.confirm("Logout", "Tem certeza que deseja fazer logout?", function() {
      $.post("logout", {}, function() {
          delete(localStorage.user);
          viewLogin();
          hasLogout();
        },
        function() {
          $.alert("Não foi possível fazer o logout. Tente novamente mais tarde.");
        });
      $.dialog.close();
    });
  }

};
